/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import model.MathData;
import model.MathOperation;
import ui.form.MathForm;

/**
 *
 * @author student1
 */
public class Controller {

    private final MathForm mathForm;
    private final MathData mathData;

    public Controller(MathForm mathForm, MathData mathData) {
        this.mathForm = mathForm;
        this.mathData = mathData;
        addListener();
        populateForm();
    }

    public void openForm() {
        mathForm.setVisible(true);
    }

    private void addListener() {
        mathForm.addBtnPlusListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae) {
//                JOptionPane.showMessageDialog(mathForm, "BtnPlus click");
                plus();
            }
        });
        mathForm.addBtnMinusListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae) {
//                JOptionPane.showMessageDialog(mathForm, "BtnMinus click");
                minus();
            }
        });
    }

    private void populateForm() {
        mathForm.getTxtA().setText(String.valueOf(mathData.getA()));
        mathForm.getTxtB().setText(String.valueOf(mathData.getB()));
        mathForm.getTxtC().setText(String.valueOf(mathData.getC()));
        mathForm.getTxtOperation().setText(mathData.getOperation().toString());
    }

    private void plus() {
        int a = Integer.parseInt(mathForm.getTxtA().getText().trim());
        int b = Integer.parseInt(mathForm.getTxtB().getText().trim());
        MathOperation operation = MathOperation.PLUS;

        mathData.setA(a);
        mathData.setB(b);
        mathData.setOperation(operation);

        mathData.calculate();

        populateForm();
    }
    
    private void minus() {
        // TODO: REFACTOR
        int a = Integer.parseInt(mathForm.getTxtA().getText().trim());
        int b = Integer.parseInt(mathForm.getTxtB().getText().trim());
        MathOperation operation = MathOperation.MINUS;

        mathData.setA(a);
        mathData.setB(b);
        mathData.setOperation(operation);

        mathData.calculate();

        populateForm();
    }

}
